#!/bin/bash

project=`bzr info | grep ruslan | tail -1 | sed -e 's/.*~/~/'`

if   [ "${1}" = "ct" ]; then
    bzr commit -m "merge with local copy"

elif [ "${1}" = "add" ]; then
    bzr add ${2}

elif [ "${1}" = "in" ]; then
    bzr info

elif [ "${1}" = "ps" ]; then
    bzr push lp:${project}

elif [ "${1}" = "mg" ]; then
    bzr merge lp:${project}

elif [ "${1}" = "st" ]; then
    bzr status

elif [ "${1}" = "cl" ]; then
    rm -rfv CMakeCache.txt
    rm -rfv cmake_install.cmake
    rm -rfv CMakeFiles
    rm -rfv devel
    rm -rfv Makefile
    rm -rfv readoutlib
    rm -rfv ../*~
    rm -rfv ../*/*~
    rm -rfv ../*/*/*~
    rm -rfv ../*/*/*/*~
    rm -rfv ../*/*/*/*/*~
    rm -rfv ../lib
    rm -rfv ../bin
    rm -rfv ../src/readoutlib/config.hh

elif [ "${1}" = "mk" ]; then
    make -j8

elif [ "${1}" = "cn" ]; then
    make clean

elif [ "${1}" = "cm" ]; then
    arg=""
    if [ -d ../../../external/gcc/gcc-4.1.2 ]; then 
	arg+="-DCMAKE_C_COMPILER=`pwd`/../../../external/gcc/gcc-4.1.2/install/usr/local/bin/gcc -DCMAKE_CXX_COMPILER=`pwd`/../../../external/gcc/gcc-4.1.2/install/usr/local/bin/g++"
    fi
    if [ -d ../../../external/root/install ]; then
	cd ../../../external/root/install/bin
	source thisroot.sh
	cd -
    fi
    if [ -d ../../../external/clhep/install ]; then
	export CLHEP=`pwd`/../../../external/clhep/install
    fi
    cmake ../src ${arg}
elif [ "${1}" = "bzr-login" ]; then
    bzr launchpad-login ruslan-asfandiyarov-r
fi
