#!/bin/bash

rm -rfv stop

spillP=15000
nEvt=${2}

if [ "${1}" = 1 ]; then # configure MAROC
    ../bin/febconfig 0x12340000 16
    sleep 1
    ../bin/febconfig 0x56780000 16
    sleep 1
    ../bin/febconfig 0xABCD0000 16
    sleep 1
    exit
elif [ "${1}" = 2 ]; then # test run
    saveDir="cosmic_data_tmp"
elif [ "${1}" = 3 ]; then # data run
    saveDir="cosmic_data"
else
    echo "ERROR: invalid mode"
    echo "mode=1 - configure MAROC"
    echo "mode=2 - test run"
    echo "mode=3 - data run"
    echo "usage ./run.bash mode nEvt"
    exit
fi

if [ -z "${nEvt}" ]; then
    echo "ERROR: number of events (nEvt) must be specified"
    echo "usage ./run.bash mode nEvt"
    exit
fi

mkdir -pv ${saveDir}/
mkdir -pv /DATA/${saveDir}/

while [ 1 ];
  do
  stamp_start=`date +%Hh%Mm%Ss_%d%h%Y`
  mkdir -pv ${saveDir}/run_${stamp_start}/
  ../bin/emrtest ${nEvt} ${spillP} 0 | tee ${saveDir}/run_${stamp_start}/emrtest.log
  stamp_end=`date +%Hh%Mm%Ss_%d%h%Y`
  echo ${stamp_start} >> ${saveDir}/run_${stamp_start}/emrtest.log
  echo ${stamp_end} >> ${saveDir}/run_${stamp_start}/emrtest.log
  mkdir -pv ${saveDir}/run_${stamp_start}/raw/
  cp -v ../data_tmp/* ${saveDir}/run_${stamp_start}/raw/
  ../bin/eventbuild 999 | tee ${saveDir}/run_${stamp_start}/eventbuild.log
  mv -v ../data_tmp/EMRdata_999.root ${saveDir}/run_${stamp_start}/events.root
  cp -rv ${saveDir}/run_${stamp_start} /DATA/${saveDir}/;
  rm -fv ../data_tmp/*
  if [ -f stop ]; then exit; fi
done
