#include "MDEv2718.hh"
#include "MiceDAQMessanger.hh"

IMPLEMENT_FUNCTIONS(V2719Params, MDEv2718)

MDEv2718::MDEv2718()
: MiceDAQEquipment::MiceDAQEquipment() {
  SET_ALL_PARAMS_TO_ZERO(V2719Params)
  mde_name_ = "V2718";
}

bool MDEv2718::Arm() {
  //Initialize V2718
  mde_messanger_->sendMessage("V2718: Going to arm a board with following parameters:", MDE_INFO );
  getInfo();

  // Set the static data member max event number.
  this->setMaxNumOfEvts( this->getParam("MaxNumEvts") );
  mde_vmeStatus_ = CAENVME_Init( cvV2718,
                                 this->getParam("BLink"),
                                 this->getParam("BNumber"),
                                 &mde_V2718_Handle_ );

  if( mde_vmeStatus_ != cvSuccess ) {
    *( mde_messanger_->getStream() ) << "V2718: Unable to initialize. Status: " << mde_vmeStatus_;
    mde_messanger_->sendMessage(MDE_FATAL);
    mde_messanger_->sendMessage("V2718: Check that the crate is ON and the controller is connected.",
                                  MDE_FATAL);
    mde_messanger_->sendMessage("V2718: Arming failed. \n", MDE_FATAL);
    return false;
  }
  /*
  mde_vmeStatus_ = CAENVME_SetOutputConf( mde_V2718_Handle_, cvOutput0, cvDirect ,
                                            cvActiveHigh, cvManualSW );

  mde_vmeStatus_ |= CAENVME_SetOutputConf( mde_V2718_Handle_, cvOutput4, cvDirect ,
                                           cvActiveHigh, cvManualSW );

  mde_vmeStatus_ = CAENVME_SetScalerConf( mde_V2718_Handle_, 0x3ff, 1, cvInputSrc0, , cvManualSW );
  */
  if( mde_vmeStatus_ != cvSuccess ) {
    *( mde_messanger_->getStream() ) << " V2718: Unable to setting output conf. Status: "<< mde_vmeStatus_;
    mde_messanger_->sendMessage(MDE_FATAL);
    mde_messanger_->sendMessage("Arming failed. \n", MDE_FATAL);

    return false;
  }

  mde_messanger_->sendMessage("V2718: Arming successful. \n", MDE_INFO);

  return true;
}

bool MDEv2718::DisArm() {
  // This will be the last equipment to be disarmed
  mde_vmeStatus_ = CAENVME_End( mde_V2718_Handle_ );
  if( mde_vmeStatus_ != cvSuccess ){
    *( mde_messanger_->getStream() ) << " V2718: Unable to initialize. Status: " << mde_vmeStatus_;
    mde_messanger_->sendMessage(MDE_ERROR);
    mde_messanger_->sendMessage("DisArming failed. \n", MDE_FATAL);
    return false;
  }

  mde_messanger_->sendMessage("V2718: Disarming successful. \n", MDE_INFO);

  return true;

}

int MDEv2718::ReadEvent() {


  return 0;
}

int MDEv2718::EventArrived() {


  return 0;
}





